/*
 * #%L
 * Reef DB :: Core
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2014 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */
//
/**
 * @author Generated on 05/05/2017 14:20:38+0200 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige2.core::vo::administration::strategy::AppliedPeriodVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige2.core.vo.administration.strategy;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Date;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
 */
public class AppliedPeriodVO
    implements Serializable, Comparable<AppliedPeriodVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 7525651096912121704L;

    // Class attributes
    /**
     * Date de début de la période applicable
     */
    protected Date appliedPeriodStartDt;
    /**
     * Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     */
    protected Date appliedPeriodEndDt;
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /** TODO: Model Documentation for attribute appliedStratId */
    protected Integer appliedStratId;

    // Class associationEnds
    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     */
    protected AppliedStrategyVO appliedStrategyVO;

    /** Default Constructor with no properties */
    public AppliedPeriodVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param appliedPeriodStartDtIn Date Date de début de la période applicable
     * @param appliedPeriodEndDtIn Date Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     * @param appliedStratIdIn Integer
     * @param appliedStrategyVOIn AppliedStrategyVO Identifie les conditions d'application locale de la stratégie pour une période donnée.
     */
    public AppliedPeriodVO(final Date appliedPeriodStartDtIn, final Date appliedPeriodEndDtIn, final Integer appliedStratIdIn, final AppliedStrategyVO appliedStrategyVOIn)
    {
        this.appliedPeriodStartDt = appliedPeriodStartDtIn;
        this.appliedPeriodEndDt = appliedPeriodEndDtIn;
        this.appliedStratId = appliedStratIdIn;
        this.appliedStrategyVO = appliedStrategyVOIn;
    }

    /**
     * Constructor with all properties
     * @param appliedPeriodStartDtIn Date
     * @param appliedPeriodEndDtIn Date
     * @param updateDtIn Timestamp
     * @param appliedStratIdIn Integer
     * @param appliedStrategyVOIn AppliedStrategyVO
     */
    public AppliedPeriodVO(final Date appliedPeriodStartDtIn, final Date appliedPeriodEndDtIn, final Timestamp updateDtIn, final Integer appliedStratIdIn, final AppliedStrategyVO appliedStrategyVOIn)
    {
        this.appliedPeriodStartDt = appliedPeriodStartDtIn;
        this.appliedPeriodEndDt = appliedPeriodEndDtIn;
        this.updateDt = updateDtIn;
        this.appliedStratId = appliedStratIdIn;
        this.appliedStrategyVO = appliedStrategyVOIn;
    }

    /**
     * Copies constructor from other AppliedPeriodVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public AppliedPeriodVO(final AppliedPeriodVO otherBean)
    {
        this.appliedPeriodStartDt = otherBean.getAppliedPeriodStartDt();
        this.appliedPeriodEndDt = otherBean.getAppliedPeriodEndDt();
        this.updateDt = otherBean.getUpdateDt();
        this.appliedStratId = otherBean.getAppliedStratId();
        this.appliedStrategyVO = otherBean.getAppliedStrategyVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final AppliedPeriodVO otherBean)
    {
        if (null != otherBean)
        {
            this.setAppliedPeriodStartDt(otherBean.getAppliedPeriodStartDt());
            this.setAppliedPeriodEndDt(otherBean.getAppliedPeriodEndDt());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setAppliedStratId(otherBean.getAppliedStratId());
            this.setAppliedStrategyVO(otherBean.getAppliedStrategyVO());
        }
    }

    /**
     * Date de début de la période applicable
     * Get the appliedPeriodStartDt Attribute
     * @return appliedPeriodStartDt Date
     */
    public Date getAppliedPeriodStartDt()
    {
        return this.appliedPeriodStartDt;
    }

    /**
     * Date de début de la période applicable
     * @param value Date
     */
    public void setAppliedPeriodStartDt(final Date value)
    {
        this.appliedPeriodStartDt = value;
    }

    /**
     * Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     * Get the appliedPeriodEndDt Attribute
     * @return appliedPeriodEndDt Date
     */
    public Date getAppliedPeriodEndDt()
    {
        return this.appliedPeriodEndDt;
    }

    /**
     * Date de fin de la période applicable. Si elle n'est pas définie, la période est en cours.
     * @param value Date
     */
    public void setAppliedPeriodEndDt(final Date value)
    {
        this.appliedPeriodEndDt = value;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * TODO: Model Documentation for attribute appliedStratId
     * Get the appliedStratId Attribute
     * @return appliedStratId Integer
     */
    public Integer getAppliedStratId()
    {
        return this.appliedStratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setAppliedStratId(final Integer value)
    {
        this.appliedStratId = value;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * Get the appliedStrategyVO Association
     * @return this.appliedStrategyVO AppliedStrategyVO
     */
    public AppliedStrategyVO getAppliedStrategyVO()
    {
        return this.appliedStrategyVO;
    }

    /**
     * Sets the appliedStrategyVO
     * @param value AppliedStrategyVO
     */
    public void setAppliedStrategyVO(AppliedStrategyVO value)
    {
        this.appliedStrategyVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        AppliedPeriodVO rhs = (AppliedPeriodVO) object;
        return new EqualsBuilder()
            .append(this.getAppliedPeriodStartDt(), rhs.getAppliedPeriodStartDt())
            .append(this.getAppliedPeriodEndDt(), rhs.getAppliedPeriodEndDt())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getAppliedStratId(), rhs.getAppliedStratId())
            .append(this.getAppliedStrategyVO(), rhs.getAppliedStrategyVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final AppliedPeriodVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getAppliedPeriodStartDt(), object.getAppliedPeriodStartDt())
            .append(this.getAppliedPeriodEndDt(), object.getAppliedPeriodEndDt())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getAppliedStratId(), object.getAppliedStratId())
            .append(this.getAppliedStrategyVO(), object.getAppliedStrategyVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getAppliedPeriodStartDt())
            .append(this.getAppliedPeriodEndDt())
            .append(this.getUpdateDt())
            .append(this.getAppliedStratId())
            .append(this.getAppliedStrategyVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("appliedPeriodStartDt", this.getAppliedPeriodStartDt())
            .append("appliedPeriodEndDt", this.getAppliedPeriodEndDt())
            .append("updateDt", this.getUpdateDt())
            .append("appliedStratId", this.getAppliedStratId())
            .append("appliedStrategyVO", this.getAppliedStrategyVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // AppliedPeriodVO value-object java merge-point
}