/*
 * #%L
 * Reef DB :: Core
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2014 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */
//
/**
 * @author Generated on 05/05/2017 14:20:38+0200 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige2.core::vo::administration::user::QuserVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige2.core.vo.administration.user;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Date;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Liste l'ensemble des agents et utilisateurs du système.
 */
public class QuserVO
    implements Serializable, Comparable<QuserVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 4074989181736461905L;

    // Class attributes
    /**
     * Identifiant interne d'un agent
     */
    protected Integer quserId;
    /**
     * Matricule : identifie de manière unique une personne dans LDAP, attribut obligatoire dans
     * LDAP
     */
    protected String quserCd;
    /**
     * Nom de l'agent, obligatoire
     */
    protected String quserLastNm;
    /**
     * Prénom de l'agent
     */
    protected String quserFirstNm;
    /**
     * UID du LDAP intranet de l'agent s'il existe
     */
    protected String quserIntranetLg;
    /**
     * UID du LDAP extranet de l'agent s'il existe
     */
    protected String quserExtranetLg;
    /**
     * Adresse électronique de la personne
     */
    protected String quserEMail;
    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     */
    protected String quserAddress;
    /**
     * Liste des téléphones de la personnes
     */
    protected String quserPhone;
    /**
     * Organisme dont dépend la personne (voir avec service)!!!
     */
    protected String quserOrgan;
    /**
     * Centre administratif dont dépend la personne (voir avec service) !!
     */
    protected String quserAdminCenter;
    /**
     * Site auquel est affectée la personne
     */
    protected String quserSite;
    /**
     * Oui, si l'utilisateur est présent dans le LDAP (code renseigné).
     */
    protected String quserLdapPresent;
    /**
     * Date de création de l'objet
     */
    protected Date quserCreationDt;
    /**
     * Date de modification de l'objet
     */
    protected Timestamp updateDt;
    /**
     * Code de l'état de l'objet (actif ou inactif)
     */
    protected String statusCd;
    /**
     * Identifiant interne d'un service
     */
    protected Integer depId;

    // Class associationEnds
    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     */
    protected DepartmentVO department;

    /** TODO: Model Documentation for attribute privileges */
    protected PrivilegeVO[] privileges;

    /** Default Constructor with no properties */
    public QuserVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param quserIdIn Integer Identifiant interne d'un agent
     * @param quserLastNmIn String Nom de l'agent, obligatoire
     * @param quserFirstNmIn String Prénom de l'agent
     * @param statusCdIn String Code de l'état de l'objet (actif ou inactif)
     * @param depIdIn Integer Identifiant interne d'un service
     * @param departmentIn DepartmentVO Liste les départements ou services auxquels sont rattachés les agents
     */
    public QuserVO(final Integer quserIdIn, final String quserLastNmIn, final String quserFirstNmIn, final String statusCdIn, final Integer depIdIn, final DepartmentVO departmentIn)
    {
        this.quserId = quserIdIn;
        this.quserLastNm = quserLastNmIn;
        this.quserFirstNm = quserFirstNmIn;
        this.statusCd = statusCdIn;
        this.depId = depIdIn;
        this.department = departmentIn;
    }

    /**
     * Constructor with all properties
     * @param quserIdIn Integer
     * @param quserCdIn String
     * @param quserLastNmIn String
     * @param quserFirstNmIn String
     * @param quserIntranetLgIn String
     * @param quserExtranetLgIn String
     * @param quserEMailIn String
     * @param quserAddressIn String
     * @param quserPhoneIn String
     * @param quserOrganIn String
     * @param quserAdminCenterIn String
     * @param quserSiteIn String
     * @param quserLdapPresentIn String
     * @param quserCreationDtIn Date
     * @param updateDtIn Timestamp
     * @param statusCdIn String
     * @param depIdIn Integer
     * @param departmentIn DepartmentVO
     * @param privilegesIn PrivilegeVO[]
     */
    public QuserVO(final Integer quserIdIn, final String quserCdIn, final String quserLastNmIn, final String quserFirstNmIn, final String quserIntranetLgIn, final String quserExtranetLgIn, final String quserEMailIn, final String quserAddressIn, final String quserPhoneIn, final String quserOrganIn, final String quserAdminCenterIn, final String quserSiteIn, final String quserLdapPresentIn, final Date quserCreationDtIn, final Timestamp updateDtIn, final String statusCdIn, final Integer depIdIn, final DepartmentVO departmentIn, final PrivilegeVO[] privilegesIn)
    {
        this.quserId = quserIdIn;
        this.quserCd = quserCdIn;
        this.quserLastNm = quserLastNmIn;
        this.quserFirstNm = quserFirstNmIn;
        this.quserIntranetLg = quserIntranetLgIn;
        this.quserExtranetLg = quserExtranetLgIn;
        this.quserEMail = quserEMailIn;
        this.quserAddress = quserAddressIn;
        this.quserPhone = quserPhoneIn;
        this.quserOrgan = quserOrganIn;
        this.quserAdminCenter = quserAdminCenterIn;
        this.quserSite = quserSiteIn;
        this.quserLdapPresent = quserLdapPresentIn;
        this.quserCreationDt = quserCreationDtIn;
        this.updateDt = updateDtIn;
        this.statusCd = statusCdIn;
        this.depId = depIdIn;
        this.department = departmentIn;
        this.privileges = privilegesIn;
    }

    /**
     * Copies constructor from other QuserVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public QuserVO(final QuserVO otherBean)
    {
        this.quserId = otherBean.getQuserId();
        this.quserCd = otherBean.getQuserCd();
        this.quserLastNm = otherBean.getQuserLastNm();
        this.quserFirstNm = otherBean.getQuserFirstNm();
        this.quserIntranetLg = otherBean.getQuserIntranetLg();
        this.quserExtranetLg = otherBean.getQuserExtranetLg();
        this.quserEMail = otherBean.getQuserEMail();
        this.quserAddress = otherBean.getQuserAddress();
        this.quserPhone = otherBean.getQuserPhone();
        this.quserOrgan = otherBean.getQuserOrgan();
        this.quserAdminCenter = otherBean.getQuserAdminCenter();
        this.quserSite = otherBean.getQuserSite();
        this.quserLdapPresent = otherBean.getQuserLdapPresent();
        this.quserCreationDt = otherBean.getQuserCreationDt();
        this.updateDt = otherBean.getUpdateDt();
        this.statusCd = otherBean.getStatusCd();
        this.depId = otherBean.getDepId();
        this.department = otherBean.getDepartment();
        this.privileges = otherBean.getPrivileges();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final QuserVO otherBean)
    {
        if (null != otherBean)
        {
            this.setQuserId(otherBean.getQuserId());
            this.setQuserCd(otherBean.getQuserCd());
            this.setQuserLastNm(otherBean.getQuserLastNm());
            this.setQuserFirstNm(otherBean.getQuserFirstNm());
            this.setQuserIntranetLg(otherBean.getQuserIntranetLg());
            this.setQuserExtranetLg(otherBean.getQuserExtranetLg());
            this.setQuserEMail(otherBean.getQuserEMail());
            this.setQuserAddress(otherBean.getQuserAddress());
            this.setQuserPhone(otherBean.getQuserPhone());
            this.setQuserOrgan(otherBean.getQuserOrgan());
            this.setQuserAdminCenter(otherBean.getQuserAdminCenter());
            this.setQuserSite(otherBean.getQuserSite());
            this.setQuserLdapPresent(otherBean.getQuserLdapPresent());
            this.setQuserCreationDt(otherBean.getQuserCreationDt());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setStatusCd(otherBean.getStatusCd());
            this.setDepId(otherBean.getDepId());
            this.setDepartment(otherBean.getDepartment());
            this.setPrivileges(otherBean.getPrivileges());
        }
    }

    /**
     * Identifiant interne d'un agent
     * Get the quserId Attribute
     * @return quserId Integer
     */
    public Integer getQuserId()
    {
        return this.quserId;
    }

    /**
     * Identifiant interne d'un agent
     * @param value Integer
     */
    public void setQuserId(final Integer value)
    {
        this.quserId = value;
    }

    /**
     * Matricule : identifie de manière unique une personne dans LDAP, attribut obligatoire dans
     * LDAP
     * Get the quserCd Attribute
     * @return quserCd String
     */
    public String getQuserCd()
    {
        return this.quserCd;
    }

    /**
     * Matricule : identifie de manière unique une personne dans LDAP, attribut obligatoire dans
     * LDAP
     * @param value String
     */
    public void setQuserCd(final String value)
    {
        this.quserCd = value;
    }

    /**
     * Nom de l'agent, obligatoire
     * Get the quserLastNm Attribute
     * @return quserLastNm String
     */
    public String getQuserLastNm()
    {
        return this.quserLastNm;
    }

    /**
     * Nom de l'agent, obligatoire
     * @param value String
     */
    public void setQuserLastNm(final String value)
    {
        this.quserLastNm = value;
    }

    /**
     * Prénom de l'agent
     * Get the quserFirstNm Attribute
     * @return quserFirstNm String
     */
    public String getQuserFirstNm()
    {
        return this.quserFirstNm;
    }

    /**
     * Prénom de l'agent
     * @param value String
     */
    public void setQuserFirstNm(final String value)
    {
        this.quserFirstNm = value;
    }

    /**
     * UID du LDAP intranet de l'agent s'il existe
     * Get the quserIntranetLg Attribute
     * @return quserIntranetLg String
     */
    public String getQuserIntranetLg()
    {
        return this.quserIntranetLg;
    }

    /**
     * UID du LDAP intranet de l'agent s'il existe
     * @param value String
     */
    public void setQuserIntranetLg(final String value)
    {
        this.quserIntranetLg = value;
    }

    /**
     * UID du LDAP extranet de l'agent s'il existe
     * Get the quserExtranetLg Attribute
     * @return quserExtranetLg String
     */
    public String getQuserExtranetLg()
    {
        return this.quserExtranetLg;
    }

    /**
     * UID du LDAP extranet de l'agent s'il existe
     * @param value String
     */
    public void setQuserExtranetLg(final String value)
    {
        this.quserExtranetLg = value;
    }

    /**
     * Adresse électronique de la personne
     * Get the quserEMail Attribute
     * @return quserEMail String
     */
    public String getQuserEMail()
    {
        return this.quserEMail;
    }

    /**
     * Adresse électronique de la personne
     * @param value String
     */
    public void setQuserEMail(final String value)
    {
        this.quserEMail = value;
    }

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * Get the quserAddress Attribute
     * @return quserAddress String
     */
    public String getQuserAddress()
    {
        return this.quserAddress;
    }

    /**
     * Adresse du site dans le LDAP, ou informations sur l'adresse de l'utilisateur.
     * @param value String
     */
    public void setQuserAddress(final String value)
    {
        this.quserAddress = value;
    }

    /**
     * Liste des téléphones de la personnes
     * Get the quserPhone Attribute
     * @return quserPhone String
     */
    public String getQuserPhone()
    {
        return this.quserPhone;
    }

    /**
     * Liste des téléphones de la personnes
     * @param value String
     */
    public void setQuserPhone(final String value)
    {
        this.quserPhone = value;
    }

    /**
     * Organisme dont dépend la personne (voir avec service)!!!
     * Get the quserOrgan Attribute
     * @return quserOrgan String
     */
    public String getQuserOrgan()
    {
        return this.quserOrgan;
    }

    /**
     * Organisme dont dépend la personne (voir avec service)!!!
     * @param value String
     */
    public void setQuserOrgan(final String value)
    {
        this.quserOrgan = value;
    }

    /**
     * Centre administratif dont dépend la personne (voir avec service) !!
     * Get the quserAdminCenter Attribute
     * @return quserAdminCenter String
     */
    public String getQuserAdminCenter()
    {
        return this.quserAdminCenter;
    }

    /**
     * Centre administratif dont dépend la personne (voir avec service) !!
     * @param value String
     */
    public void setQuserAdminCenter(final String value)
    {
        this.quserAdminCenter = value;
    }

    /**
     * Site auquel est affectée la personne
     * Get the quserSite Attribute
     * @return quserSite String
     */
    public String getQuserSite()
    {
        return this.quserSite;
    }

    /**
     * Site auquel est affectée la personne
     * @param value String
     */
    public void setQuserSite(final String value)
    {
        this.quserSite = value;
    }

    /**
     * Oui, si l'utilisateur est présent dans le LDAP (code renseigné).
     * Get the quserLdapPresent Attribute
     * @return quserLdapPresent String
     */
    public String getQuserLdapPresent()
    {
        return this.quserLdapPresent;
    }

    /**
     * Oui, si l'utilisateur est présent dans le LDAP (code renseigné).
     * @param value String
     */
    public void setQuserLdapPresent(final String value)
    {
        this.quserLdapPresent = value;
    }

    /**
     * Date de création de l'objet
     * Get the quserCreationDt Attribute
     * @return quserCreationDt Date
     */
    public Date getQuserCreationDt()
    {
        return this.quserCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param value Date
     */
    public void setQuserCreationDt(final Date value)
    {
        this.quserCreationDt = value;
    }

    /**
     * Date de modification de l'objet
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * Get the statusCd Attribute
     * @return statusCd String
     */
    public String getStatusCd()
    {
        return this.statusCd;
    }

    /**
     * Code de l'état de l'objet (actif ou inactif)
     * @param value String
     */
    public void setStatusCd(final String value)
    {
        this.statusCd = value;
    }

    /**
     * Identifiant interne d'un service
     * Get the depId Attribute
     * @return depId Integer
     */
    public Integer getDepId()
    {
        return this.depId;
    }

    /**
     * Identifiant interne d'un service
     * @param value Integer
     */
    public void setDepId(final Integer value)
    {
        this.depId = value;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * Get the department Association
     * @return this.department DepartmentVO
     */
    public DepartmentVO getDepartment()
    {
        return this.department;
    }

    /**
     * Sets the department
     * @param value DepartmentVO
     */
    public void setDepartment(DepartmentVO value)
    {
        this.department = value;
    }

    /**
     * TODO: Model Documentation for association privileges
     * Get the privileges Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.privileges PrivilegeVO[]
     */
    public PrivilegeVO[] getPrivileges()
    {
        return this.privileges;
    }

    /**
     * Sets the privileges
     * @param value PrivilegeVO[]
     */
    public void setPrivileges(PrivilegeVO[] value)
    {
        this.privileges = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        QuserVO rhs = (QuserVO) object;
        return new EqualsBuilder()
            .append(this.getQuserId(), rhs.getQuserId())
            .append(this.getQuserCd(), rhs.getQuserCd())
            .append(this.getQuserLastNm(), rhs.getQuserLastNm())
            .append(this.getQuserFirstNm(), rhs.getQuserFirstNm())
            .append(this.getQuserIntranetLg(), rhs.getQuserIntranetLg())
            .append(this.getQuserExtranetLg(), rhs.getQuserExtranetLg())
            .append(this.getQuserEMail(), rhs.getQuserEMail())
            .append(this.getQuserAddress(), rhs.getQuserAddress())
            .append(this.getQuserPhone(), rhs.getQuserPhone())
            .append(this.getQuserOrgan(), rhs.getQuserOrgan())
            .append(this.getQuserAdminCenter(), rhs.getQuserAdminCenter())
            .append(this.getQuserSite(), rhs.getQuserSite())
            .append(this.getQuserLdapPresent(), rhs.getQuserLdapPresent())
            .append(this.getQuserCreationDt(), rhs.getQuserCreationDt())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getStatusCd(), rhs.getStatusCd())
            .append(this.getDepId(), rhs.getDepId())
            .append(this.getDepartment(), rhs.getDepartment())
            .append(this.getPrivileges(), rhs.getPrivileges())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final QuserVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getQuserId(), object.getQuserId())
            .append(this.getQuserCd(), object.getQuserCd())
            .append(this.getQuserLastNm(), object.getQuserLastNm())
            .append(this.getQuserFirstNm(), object.getQuserFirstNm())
            .append(this.getQuserIntranetLg(), object.getQuserIntranetLg())
            .append(this.getQuserExtranetLg(), object.getQuserExtranetLg())
            .append(this.getQuserEMail(), object.getQuserEMail())
            .append(this.getQuserAddress(), object.getQuserAddress())
            .append(this.getQuserPhone(), object.getQuserPhone())
            .append(this.getQuserOrgan(), object.getQuserOrgan())
            .append(this.getQuserAdminCenter(), object.getQuserAdminCenter())
            .append(this.getQuserSite(), object.getQuserSite())
            .append(this.getQuserLdapPresent(), object.getQuserLdapPresent())
            .append(this.getQuserCreationDt(), object.getQuserCreationDt())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getStatusCd(), object.getStatusCd())
            .append(this.getDepId(), object.getDepId())
            .append(this.getDepartment(), object.getDepartment())
            .append(this.getPrivileges(), object.getPrivileges())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getQuserId())
            .append(this.getQuserCd())
            .append(this.getQuserLastNm())
            .append(this.getQuserFirstNm())
            .append(this.getQuserIntranetLg())
            .append(this.getQuserExtranetLg())
            .append(this.getQuserEMail())
            .append(this.getQuserAddress())
            .append(this.getQuserPhone())
            .append(this.getQuserOrgan())
            .append(this.getQuserAdminCenter())
            .append(this.getQuserSite())
            .append(this.getQuserLdapPresent())
            .append(this.getQuserCreationDt())
            .append(this.getUpdateDt())
            .append(this.getStatusCd())
            .append(this.getDepId())
            .append(this.getDepartment())
            .append(this.getPrivileges())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("quserId", this.getQuserId())
            .append("quserCd", this.getQuserCd())
            .append("quserLastNm", this.getQuserLastNm())
            .append("quserFirstNm", this.getQuserFirstNm())
            .append("quserIntranetLg", this.getQuserIntranetLg())
            .append("quserExtranetLg", this.getQuserExtranetLg())
            .append("quserEMail", this.getQuserEMail())
            .append("quserAddress", this.getQuserAddress())
            .append("quserPhone", this.getQuserPhone())
            .append("quserOrgan", this.getQuserOrgan())
            .append("quserAdminCenter", this.getQuserAdminCenter())
            .append("quserSite", this.getQuserSite())
            .append("quserLdapPresent", this.getQuserLdapPresent())
            .append("quserCreationDt", this.getQuserCreationDt())
            .append("updateDt", this.getUpdateDt())
            .append("statusCd", this.getStatusCd())
            .append("depId", this.getDepId())
            .append("department", this.getDepartment())
            .append("privileges", this.getPrivileges())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // QuserVO value-object java merge-point
}